// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.22.0

package generated

import (
	"context"
	"database/sql"
	"fmt"
)

type DBTX interface {
	ExecContext(context.Context, string, ...interface{}) (sql.Result, error)
	PrepareContext(context.Context, string) (*sql.Stmt, error)
	QueryContext(context.Context, string, ...interface{}) (*sql.Rows, error)
	QueryRowContext(context.Context, string, ...interface{}) *sql.Row
}

func New(db DBTX) *Queries {
	return &Queries{db: db}
}

func Prepare(ctx context.Context, db DBTX) (*Queries, error) {
	q := Queries{db: db}
	var err error
	if q.assessmentCreateStmt, err = db.PrepareContext(ctx, assessmentCreate); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentCreate: %w", err)
	}
	if q.assessmentDeleteStmt, err = db.PrepareContext(ctx, assessmentDelete); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentDelete: %w", err)
	}
	if q.assessmentGetStmt, err = db.PrepareContext(ctx, assessmentGet); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentGet: %w", err)
	}
	if q.assessmentListStmt, err = db.PrepareContext(ctx, assessmentList); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentList: %w", err)
	}
	return &q, nil
}

func (q *Queries) Close() error {
	var err error
	if q.assessmentCreateStmt != nil {
		if cerr := q.assessmentCreateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentCreateStmt: %w", cerr)
		}
	}
	if q.assessmentDeleteStmt != nil {
		if cerr := q.assessmentDeleteStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentDeleteStmt: %w", cerr)
		}
	}
	if q.assessmentGetStmt != nil {
		if cerr := q.assessmentGetStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentGetStmt: %w", cerr)
		}
	}
	if q.assessmentListStmt != nil {
		if cerr := q.assessmentListStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentListStmt: %w", cerr)
		}
	}
	return err
}

func (q *Queries) exec(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) (sql.Result, error) {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).ExecContext(ctx, args...)
	case stmt != nil:
		return stmt.ExecContext(ctx, args...)
	default:
		return q.db.ExecContext(ctx, query, args...)
	}
}

func (q *Queries) query(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) (*sql.Rows, error) {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).QueryContext(ctx, args...)
	case stmt != nil:
		return stmt.QueryContext(ctx, args...)
	default:
		return q.db.QueryContext(ctx, query, args...)
	}
}

func (q *Queries) queryRow(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) *sql.Row {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).QueryRowContext(ctx, args...)
	case stmt != nil:
		return stmt.QueryRowContext(ctx, args...)
	default:
		return q.db.QueryRowContext(ctx, query, args...)
	}
}

type Queries struct {
	db                   DBTX
	tx                   *sql.Tx
	assessmentCreateStmt *sql.Stmt
	assessmentDeleteStmt *sql.Stmt
	assessmentGetStmt    *sql.Stmt
	assessmentListStmt   *sql.Stmt
}

func (q *Queries) WithTx(tx *sql.Tx) *Queries {
	return &Queries{
		db:                   tx,
		tx:                   tx,
		assessmentCreateStmt: q.assessmentCreateStmt,
		assessmentDeleteStmt: q.assessmentDeleteStmt,
		assessmentGetStmt:    q.assessmentGetStmt,
		assessmentListStmt:   q.assessmentListStmt,
	}
}
